#include <stdio.h>
#include <unistd.h>

#include "ColoredLightPOD.h"

ColoredLightPOD::ColoredLightPOD() : LightPOD()
{
#if (DEBUG_OBJECTS)
   printf("In ColoredLightPOD ()\n");
#endif
   PODType = POD_TYPE_LIGHT;
}

ColoredLightPOD::ColoredLightPOD(int DeviceNum,int PortNum) : LightPOD(DeviceNum, PortNum)
{
#if (DEBUG_OBJECTS)
   printf("In ColoredLightPOD (%d, %d)\n", DeviceNum, PortNum);
#endif
   if (PODType != POD_TYPE_LIGHT) printf("I'm not that type of POD\n");
}

ColoredLightPOD::ColoredLightPOD(int DeviceNum) : LightPOD(DeviceNum)
{
#if (DEBUG_OBJECTS)
   printf("In ColoredLightPOD (%d)\n", DeviceNum);
#endif
   if (PODType != POD_TYPE_LIGHT) printf("I'm not that type of POD\n");
}

int ColoredLightPOD::Test()
{
//   unsigned long Delay = 250000;
   unsigned long Delay = 4000000;
   int CurrentStatus;

   printf("Testing the lights.");
   AllOff();

   printf("Red...");
   fflush(stdout);
   Red(1);
   CurrentStatus = GetStatus();
   printf("0x%02X", CurrentStatus);
   usleep(Delay);
   AllOff();

   printf("Green...");
   fflush(stdout);
   Green(1);
   CurrentStatus = GetStatus();
   printf("0x%02X", CurrentStatus);
   usleep(Delay);
   AllOff();

   printf("Yellow...");
   fflush(stdout);
   Yellow(1);
   CurrentStatus = GetStatus();
   printf("0x%02X", CurrentStatus);
   usleep(Delay);
   AllOff();

   printf("White...");
   fflush(stdout);
   White(1);
   CurrentStatus = GetStatus();
   printf("0x%02X", CurrentStatus);
   usleep(Delay);
   AllOff();

   printf("All...");
   fflush(stdout);
   AllOn();
   CurrentStatus = GetStatus();
   printf("0x%02X", CurrentStatus);
   usleep(Delay);
   AllOff();

   printf("Done\n");
   return(0);
}

int ColoredLightPOD::Yellow(int OnOff)
{
   int CurrentStatus;

   CurrentStatus = GetStatus();
   TurnOn(OnOff & 0x01, CurrentStatus & 0x02, CurrentStatus & 0x04, CurrentStatus & 0x08);
   return(POD_ERROR_NONE);
}

int ColoredLightPOD::White(int OnOff)
{
   int CurrentStatus;

   CurrentStatus = GetStatus();
   TurnOn(CurrentStatus & 0x01, OnOff & 0x01, CurrentStatus & 0x04, CurrentStatus & 0x08);
   return(POD_ERROR_NONE);
}

int ColoredLightPOD::Red(int OnOff)
{
   int CurrentStatus;

   CurrentStatus = GetStatus();
   TurnOn(CurrentStatus & 0x01, CurrentStatus & 0x02, OnOff & 0x01, CurrentStatus & 0x08);
   return(POD_ERROR_NONE);
}

int ColoredLightPOD::Green(int OnOff)
{
   int CurrentStatus;

   CurrentStatus = GetStatus();
   TurnOn(CurrentStatus & 0x01, CurrentStatus & 0x02, CurrentStatus & 0x04, OnOff & 0x01);
   return(POD_ERROR_NONE);
}

