#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <termios.h>
#include <string.h>
#include <sys/select.h>
#include <sys/types.h>

#include <PODEnv.h>

class Robot : public PODEnv
{
   public:
      Robot();

      int Stop();
   protected:
      MotorControlPOD *LeftMotor;
      MotorControlPOD *RightMotor;
   private:
      POD *FindPOD(int POD_Type, char *POD_Name);
};

Robot::Robot() : PODEnv(POD_ENV_OPTION_TEXT_STATUS)
{

   LeftMotor = dynamic_cast <MotorControlPOD *>
      (FindPOD(POD_TYPE_MOTORCONTROL, "Left"));
   RightMotor = dynamic_cast <MotorControlPOD *>
      (FindPOD(POD_TYPE_MOTORCONTROL, "Right"));
}


POD *Robot::FindPOD(int POD_Type, char *POD_Name)
{
   POD *TempPOD;

   TempPOD = FindPODByName(POD_Type, POD_Name);
   if (! TempPOD)
   {
      printf("Could not find POD named \"%s\"\n", POD_Name);
//      printf("Could not find \"%s\" POD\r", POD_Text);
      return(TempPOD);
   }
   return(TempPOD);
}

int Robot::Stop()
{
   RightMotor->Stop();
   LeftMotor->Stop();

   return(0);
}

int main(int argc, char *argv[])
{
   Robot *MyRobot;

   MyRobot = new Robot();

   MyRobot->Stop();

   return(0);
}
