#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <PODEnv.h>

double When()
{
    struct timeval tp;
    gettimeofday(&tp, NULL);
    return ((double) tp.tv_sec + (double) tp.tv_usec * 1e-6);
}

void ShowButtonStatus(ButtonsPOD *MyPOD, int NumberOfButtons)
{
   int Counter;
   double StartTime;
   double EndTime;
   static char OldStatus = 0xFF;
   char NewStatus;

   if (MyPOD != NULL)
   {
      StartTime = When();
      NewStatus = 0;
      for (Counter = 0 ; Counter < NumberOfButtons ; Counter ++)
      {
         NewStatus |= (MyPOD->GetStatus(Counter) << Counter);
      }
      if (NewStatus != OldStatus)
      {
         for (Counter = 0 ; Counter < NumberOfButtons ; Counter ++)
         {
            printf("%d\t", (NewStatus >> Counter) & 0x01);
         }
         EndTime = When();
         printf("%01.4lf sec.", EndTime - StartTime);
         printf("\r");
         fflush(stdout);
      }
      OldStatus = NewStatus;
   }
}

int main(int argc, char *argv)
{
   PODEnv *MyPODs;
   ButtonsPOD *MyPOD;
   int Counter;
   int NumberOfButtons;

   MyPODs = new PODEnv(POD_ENV_OPTION_GUI_STATUS | POD_ENV_OPTION_TEXT_STATUS);
   MyPOD = dynamic_cast<ButtonsPOD *>(MyPODs->FindPODByType(POD_TYPE_BUTTONS));
//   printf("Device %d\n", MyPOD->GetDeviceNumber());
//   MyPOD = new ButtonsPOD(4);
   if (MyPOD != NULL)
   {
      NumberOfButtons = MyPOD->GetNumberOfButtons();
      printf("ButtonsPOD has %d buttons\n", NumberOfButtons);
      for (Counter = 0 ; Counter < NumberOfButtons ; Counter ++)
      {
         printf("Button %d: %d\n", Counter, MyPOD->GetStatus(Counter));
      }
      for (Counter = 0 ; Counter < NumberOfButtons ; Counter ++)
      {
         if (Counter >= (NumberOfButtons - 1)) printf("%d", Counter + 1);
         else printf("%d\t", Counter + 1);
      }
      printf("\n");
      while (1)
      {
         ShowButtonStatus(MyPOD, NumberOfButtons);
      }
   }
   else
   {
      printf("Not a ButtonsPOD\n");
   }
}

